pcl::Feature< PointInT, PointOutT > Class Template Referenceabstract
Module features

Feature represents the base feature class. More...

`#include <pcl/features/feature.h>`

Inheritance diagram for pcl::Feature< PointInT, PointOutT >:

## Public Types

using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::Feature< PointInT, PointOutT >

Feature represents the base feature class.

Some generic 3D operations that are applicable to all features are defined here as static methods.

Attention
  The convention for a feature descriptor is:
  - if the nearest neighbors for the query point at which the descriptor is to be computed cannot be determined, the descriptor values will be set to NaN (not a number)
  - it is impossible to estimate a feature descriptor for a point that doesn't have finite 3D coordinates. Therefore, any point that has NaN data on x, y, or z, will most likely have its descriptor set to NaN.

Author
  Radu B. Rusu

Definition at line 105 of file feature.h.

## Member Typedef Documentation

## BaseClass

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::BaseClass = PCLBase<PointInT>

Definition at line 111 of file feature.h.

## ConstPtr

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::ConstPtr = shared_ptr< const Feature<PointInT, PointOutT> >

Definition at line 114 of file feature.h.

## KdTree

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::KdTree = pcl::search::Search<PointInT>

Definition at line 116 of file feature.h.

## KdTreePtr

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::KdTreePtr = typename KdTree::Ptr

Definition at line 117 of file feature.h.

## PointCloudIn

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::PointCloudIn = pcl::PointCloud<PointInT>

Definition at line 119 of file feature.h.

## PointCloudInConstPtr

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::PointCloudInConstPtr = typename PointCloudIn::ConstPtr

Definition at line 121 of file feature.h.

## PointCloudInPtr

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::PointCloudInPtr = typename PointCloudIn::Ptr

Definition at line 120 of file feature.h.

## PointCloudOut

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::PointCloudOut = pcl::PointCloud<PointOutT>

Definition at line 123 of file feature.h.

## Ptr

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::Ptr = shared_ptr< Feature<PointInT, PointOutT> >

Definition at line 113 of file feature.h.

## SearchMethod

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::SearchMethod = std::function<int (std::size_t, double, std::vector<int> &, std::vector<float> &)>

Definition at line 125 of file feature.h.

## SearchMethodSurface

template<typename PointInT, typename PointOutT>

using pcl::Feature< PointInT, PointOutT >::SearchMethodSurface = std::function<int (const PointCloudIn &cloud, std::size_t index, double, std::vector<int> &, std::vector<float> &)>

Definition at line 126 of file feature.h.

## Constructor & Destructor Documentation

## Feature()

template<typename PointInT, typename PointOutT>

pcl::Feature< PointInT, PointOutT >::Feature | ( |  | ) |

inline

Empty constructor.

Definition at line 130 of file feature.h.

## ~Feature()

template<typename PointInT, typename PointOutT>

virtual pcl::Feature< PointInT, PointOutT >::~Feature | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 138 of file feature.h.

## Member Function Documentation

## compute()

template<typename PointInT , typename PointOutT >

void pcl::Feature< PointInT, PointOutT >::compute | ( | PointCloudOut & | output | ) |

Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  [out] | output | the resultant point cloud model dataset containing the estimated features

Definition at line 192 of file feature.hpp.

Referenced by pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::UnaryClassifier< PointT >::computeFPFH(), pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >::computeRf(), pcl::SurfaceNormalModality< PointXYZT >::computeSurfaceNormals(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::gpu::DataSource::estimateNormals(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::initCompute(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::initCompute(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::initCompute(), and pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::initCompute().

## deinitCompute()

template<typename PointInT , typename PointOutT >

bool pcl::Feature< PointInT, PointOutT >::deinitCompute | ( |  | ) |

protected virtual

This method should get called after ending the actual computation.

Reimplemented in pcl::FLARELocalReferenceFrameEstimation< PointInT, PointNT, PointOutT, SignedDistanceT >.

Definition at line 179 of file feature.hpp.

Referenced by pcl::SpinImageEstimation< PointInT, PointNT, PointOutT >::initCompute().

## getClassName()

template<typename PointInT, typename PointOutT>

const std::string& pcl::Feature< PointInT, PointOutT >::getClassName | ( |  | ) | const

inline protected

Get a string representation of the name of this class.

Definition at line 246 of file feature.h.

Referenced by pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setKSearch().

## getKSearch()

template<typename PointInT, typename PointOutT>

int pcl::Feature< PointInT, PointOutT >::getKSearch | ( |  | ) | const

inline

get the number of k nearest neighbors used for the feature estimation.

Definition at line 190 of file feature.h.

## getRadiusSearch()

template<typename PointInT, typename PointOutT>

double pcl::Feature< PointInT, PointOutT >::getRadiusSearch | ( |  | ) | const

inline

Get the sphere radius used for determining the neighbors.

Definition at line 207 of file feature.h.

## getSearchMethod()

template<typename PointInT, typename PointOutT>

KdTreePtr pcl::Feature< PointInT, PointOutT >::getSearchMethod | ( |  | ) | const

inline

Get a pointer to the search method used.

Definition at line 170 of file feature.h.

## getSearchParameter()

template<typename PointInT, typename PointOutT>

double pcl::Feature< PointInT, PointOutT >::getSearchParameter | ( |  | ) | const

inline

Get the internal search parameter.

Definition at line 177 of file feature.h.

## getSearchSurface()

template<typename PointInT, typename PointOutT>

PointCloudInConstPtr pcl::Feature< PointInT, PointOutT >::getSearchSurface | ( |  | ) | const

inline

Get a pointer to the surface point cloud dataset.

Definition at line 157 of file feature.h.

## initCompute()

template<typename PointInT , typename PointOutT >

bool pcl::Feature< PointInT, PointOutT >::initCompute | ( |  | ) |

protected virtual

This method should get called before starting the actual computation.

Reimplemented in pcl::SpinImageEstimation< PointInT, PointNT, PointOutT >, pcl::FLARELocalReferenceFrameEstimation< PointInT, PointNT, PointOutT, SignedDistanceT >, pcl::VFHEstimation< PointInT, PointNT, PointOutT >, pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >, pcl::ShapeContext3DEstimation< PointInT, PointNT, PointOutT >, pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >, pcl::SHOTEstimationBase< PointInT, PointNT, PointOutT, PointRFT >, pcl::DifferenceOfNormalsEstimation< PointInT, PointNT, PointOutT >, pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >, pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >, pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >, and pcl::FeatureFromNormals< PointT, PointNT, PointFeature >.

Definition at line 93 of file feature.hpp.

## searchForNeighbors() [1/2]

template<typename PointInT, typename PointOutT>

int pcl::Feature< PointInT, PointOutT >::searchForNeighbors | ( | const PointCloudIn & | cloud,
|  | std::size_t | index,
|  | double | parameter,
|  | std::vector< int > & | indices,
|  | std::vector< float > & | distances
| ) |  | const

inline protected

Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.

Parameters

  [in] | cloud | the query point cloud
  [in] | index | the index of the query point in cloud
  [in] | parameter | the search parameter (either k or radius)
  [out] | indices | the resultant vector of indices representing the k-nearest neighbors
  [out] | distances | the resultant vector of distances representing the distances from the query point to the k-nearest neighbors

Returns
  the number of neighbors found. If no neighbors are found or an error occurred, return 0.

Definition at line 288 of file feature.h.

## searchForNeighbors() [2/2]

template<typename PointInT, typename PointOutT>

int pcl::Feature< PointInT, PointOutT >::searchForNeighbors | ( | std::size_t | index,
|  | double | parameter,
|  | std::vector< int > & | indices,
|  | std::vector< float > & | distances
| ) |  | const

inline protected

Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.

Parameters

  [in] | index | the index of the query point
  [in] | parameter | the search parameter (either k or radius)
  [out] | indices | the resultant vector of indices representing the k-nearest neighbors
  [out] | distances | the resultant vector of distances representing the distances from the query point to the k-nearest neighbors

Returns
  the number of neighbors found. If no neighbors are found or an error occurred, return 0.

Definition at line 270 of file feature.h.

## setKSearch()

template<typename PointInT, typename PointOutT>

void pcl::Feature< PointInT, PointOutT >::setKSearch | ( | int | k | ) |

inline

Set the number of k nearest neighbors to use for the feature estimation.

Parameters

  [in] | k | the number of k-nearest neighbors

Definition at line 186 of file feature.h.

Referenced by pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >::computeRf(), and pcl::gpu::DataSource::estimateNormals().

## setRadiusSearch()

template<typename PointInT, typename PointOutT>

void pcl::Feature< PointInT, PointOutT >::setRadiusSearch | ( | double | radius | ) |

inline

Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.

Parameters

  [in] | radius | the sphere radius used as the maximum distance to consider a point a neighbor

Definition at line 200 of file feature.h.

Referenced by pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::UnaryClassifier< PointT >::computeFPFH(), pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >::computeRf(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), pcl::SHOTEstimationBase< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::initCompute(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::initCompute(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::initCompute(), pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), and pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::initCompute().

## setSearchMethod()

template<typename PointInT, typename PointOutT>

void pcl::Feature< PointInT, PointOutT >::setSearchMethod | ( | const KdTreePtr & | tree | ) |

inline

Provide a pointer to the search object.

Parameters

  [in] | tree | a pointer to the spatial search object.

Definition at line 166 of file feature.h.

Referenced by pcl::UnaryClassifier< PointT >::computeFPFH(), and pcl::gpu::DataSource::estimateNormals().

## setSearchSurface()

template<typename PointInT, typename PointOutT>

void pcl::Feature< PointInT, PointOutT >::setSearchSurface | ( | const PointCloudInConstPtr & | cloud | ) |

inline

Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.

This is optional, if this is not set, it will only use the data in the input cloud to estimate the features. This is useful when you only need to compute the features for a downsampled cloud.

Parameters

  [in] | cloud | a pointer to a PointCloud message

Definition at line 148 of file feature.h.

Referenced by pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), pcl::SHOTEstimationBase< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::initCompute(), and pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::initCompute().

## Member Data Documentation

## fake_surface_

template<typename PointInT, typename PointOutT>

bool pcl::Feature< PointInT, PointOutT >::fake_surface_

protected

If no surface is given, we use the input PointCloud as the surface.

Definition at line 257 of file feature.h.

Referenced by pcl::Feature< PointWithRange, Narf36 >::setSearchSurface().

## feature_name_

template<typename PointInT, typename PointOutT>

std::string pcl::Feature< PointInT, PointOutT >::feature_name_

protected

The feature name.

Definition at line 222 of file feature.h.

Referenced by pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::BOARDLocalReferenceFrameEstimation(), pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::BoundaryEstimation(), pcl::CPPFEstimation< PointInT, PointNT, PointOutT >::CPPFEstimation(), pcl::CRHEstimation< PointInT, PointNT, PointOutT >::CRHEstimation(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::CVFHEstimation(), pcl::DifferenceOfNormalsEstimation< PointInT, PointNT, PointOutT >::DifferenceOfNormalsEstimation(), pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation(), pcl::FLARELocalReferenceFrameEstimation< PointInT, PointNT, PointOutT, SignedDistanceT >::FLARELocalReferenceFrameEstimation(), pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::FPFHEstimation(), pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::FPFHEstimationOMP(), pcl::GASDColorEstimation< PointInT, PointOutT >::GASDColorEstimation(), pcl::GASDEstimation< PointInT, PointOutT >::GASDEstimation(), pcl::Feature< PointWithRange, Narf36 >::getClassName(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::GFPFHEstimation(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::GRSDEstimation(), pcl::IntegralImageNormalEstimation< pcl::PointXYZRGBA, pcl::Normal >::IntegralImageNormalEstimation(), pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::IntensityGradientEstimation(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::IntensitySpinEstimation(), pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::LinearLeastSquaresNormalEstimation(), pcl::MomentInvariantsEstimation< PointInT, PointOutT >::MomentInvariantsEstimation(), pcl::NormalEstimation< PointInT, PointNT >::NormalEstimation(), pcl::NormalEstimationOMP< PointInT, PointOutT >::NormalEstimationOMP(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::OURCVFHEstimation(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::PFHEstimation(), pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::PFHRGBEstimation(), pcl::PPFEstimation< PointInT, PointNT, PointOutT >::PPFEstimation(), pcl::PPFRGBEstimation< PointInT, PointNT, PointOutT >::PPFRGBEstimation(), pcl::PPFRGBRegionEstimation< PointInT, PointNT, PointOutT >::PPFRGBRegionEstimation(), pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::PrincipalCurvaturesEstimation(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::RIFTEstimation(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::RSDEstimation(), pcl::IntegralImageNormalEstimation< pcl::PointXYZRGBA, pcl::Normal >::setNormalSmoothingSize(), pcl::ShapeContext3DEstimation< PointInT, PointNT, PointOutT >::ShapeContext3DEstimation(), pcl::SHOTColorEstimation< PointInT, PointNT, PointOutT, PointRFT >::SHOTColorEstimation(), pcl::SHOTEstimation< PointInT, PointNT, PointOutT, PointRFT >::SHOTEstimation(), pcl::SHOTEstimationBase< PointInT, PointNT, PointOutT, PointRFT >::SHOTEstimationBase(), pcl::SHOTLocalReferenceFrameEstimation< PointInT, PointOutT >::SHOTLocalReferenceFrameEstimation(), pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::SHOTLocalReferenceFrameEstimationOMP(), pcl::SpinImageEstimation< PointInT, PointNT, PointOutT >::SpinImageEstimation(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::UniqueShapeContext(), and pcl::VFHEstimation< PointInT, PointNT, PointOutT >::VFHEstimation().

## k_

template<typename PointInT, typename PointOutT>

int pcl::Feature< PointInT, PointOutT >::k_

protected

The number of K nearest neighbors to use for each point.

Definition at line 242 of file feature.h.

Referenced by pcl::CRHEstimation< PointInT, PointNT, PointOutT >::CRHEstimation(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::CVFHEstimation(), pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation(), pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::FeatureFromLabels(), pcl::GASDEstimation< PointInT, PointOutT >::GASDEstimation(), pcl::Feature< PointWithRange, Narf36 >::getKSearch(), pcl::IntegralImageNormalEstimation< pcl::PointXYZRGBA, pcl::Normal >::IntegralImageNormalEstimation(), pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::LinearLeastSquaresNormalEstimation(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::OURCVFHEstimation(), pcl::Feature< PointWithRange, Narf36 >::setKSearch(), and pcl::VFHEstimation< PointInT, PointNT, PointOutT >::VFHEstimation().

## search_method_surface_

template<typename PointInT, typename PointOutT>

SearchMethodSurface pcl::Feature< PointInT, PointOutT >::search_method_surface_

protected

The search method template for points.

Definition at line 225 of file feature.h.

Referenced by pcl::Feature< PointWithRange, Narf36 >::searchForNeighbors().

## search_parameter_

template<typename PointInT, typename PointOutT>

double pcl::Feature< PointInT, PointOutT >::search_parameter_

protected

The actual search parameter (from either search_radius_ or k_).

Definition at line 236 of file feature.h.

Referenced by pcl::Feature< PointWithRange, Narf36 >::getSearchParameter().

## search_radius_

template<typename PointInT, typename PointOutT>

double pcl::Feature< PointInT, PointOutT >::search_radius_

protected

The nearest neighbors search radius for each point.

Definition at line 239 of file feature.h.

Referenced by pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::CVFHEstimation(), pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation(), pcl::GASDEstimation< PointInT, PointOutT >::GASDEstimation(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::getRadiusSearch(), pcl::Feature< PointWithRange, Narf36 >::getRadiusSearch(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::OURCVFHEstimation(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::setRadiusSearch(), pcl::Feature< PointWithRange, Narf36 >::setRadiusSearch(), pcl::ShapeContext3DEstimation< PointInT, PointNT, PointOutT >::ShapeContext3DEstimation(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::UniqueShapeContext(), and pcl::VFHEstimation< PointInT, PointNT, PointOutT >::VFHEstimation().

## surface_

template<typename PointInT, typename PointOutT>

PointCloudInConstPtr pcl::Feature< PointInT, PointOutT >::surface_

protected

An input point cloud describing the surface that is to be used for nearest neighbors estimation.

Definition at line 230 of file feature.h.

Referenced by pcl::Feature< PointWithRange, Narf36 >::getSearchSurface(), and pcl::Feature< PointWithRange, Narf36 >::setSearchSurface().

## tree_

template<typename PointInT, typename PointOutT>

KdTreePtr pcl::Feature< PointInT, PointOutT >::tree_

protected

A pointer to the spatial search object.

Definition at line 233 of file feature.h.

Referenced by pcl::Feature< PointWithRange, Narf36 >::getSearchMethod(), pcl::IntegralImageNormalEstimation< pcl::PointXYZRGBA, pcl::Normal >::IntegralImageNormalEstimation(), pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::LinearLeastSquaresNormalEstimation(), and pcl::Feature< PointWithRange, Narf36 >::setSearchMethod().

The documentation for this class was generated from the following files:

- pcl/features/feature.h
- pcl/features/impl/feature.hpp